(* =============================================================

   the signature of a LOGIC

============================================================= *)
signature Logic =
   sig

   local

   open Parse HolKernel 
   open L0_emb_basic L0_emb_mldata 
   open Logic_Util 

   in

   type Lstate    (* the state to thread vcs produced by the Logic *)
   type Loption  (* the state to keep Logic's options *)

   val wpAlgebra  : wpalg_INSTR_                

   val option    : Loption ref 

   (* a function to guess invariant *)
   val guessInv   : (term -> term -> term) ref 

   (* a function to retrieve the (entire) specification of a program *)
   val getSpec    : (string -> thm) ref 

   (* WP's state *)
   val state      : Lstate ref 
   val initializeState : unit -> unit                  

   (* adding and retrieving VCs to/from the state *)
   val add_VCs    : VC list -> unit            
   val get_VCs    : unit -> VC list                

   (* obtaining error-echo option *)
   val isErrorEchoOn : unit -> bool
   end 
end 

