local

open Parse HolKernel

in

(* ---

   Here are an algebra and the corresponding fold over HOL term

*)

type 'r algTerm = { fvar   : string -> hol_type -> 'r
                  , fconst : string -> hol_type -> 'r
                  , fcomb  : 'r -> 'r -> 'r
                  , fabs   : string -> hol_type -> 'r -> 'r
                  }

fun fold_term (algTerm : 'r algTerm) (t:term) =
     let
     fun worker t = 
         if is_var t 

         then (uncurry (#fvar algTerm) o dest_var) t

         else if is_const t

         then (uncurry (#fvar algTerm) o dest_const) t

         else if is_comb t

         then let
              val (f,x) = dest_comb t
              in
               (#fcomb algTerm) (worker f) (worker x)
              end

         else (* then t must be an abs *)

               let
               val (v,b) = dest_abs t
               val (vname,ty) = dest_var v
               in
               (#fabs algTerm) vname ty (worker b)
               end
    in
    worker t 
    end

end ;